<?php
if (!isset($_SERVER['PHP_AUTH_USER'])) {
    header("Location: ../");
    exit;
}
set_time_limit(0);
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="stylesheet" href="../styles/default/css/style.css" type="text/css">
<title>123solar Updater</title>
</head>
<body>
<br>
<table width="80%" border="0" cellspacing="0" cellpadding="0" align="center">
<tr><td>
<?php
$CURDIR = dirname(dirname(__FILE__));
$SRVDIR = $_SERVER['DOCUMENT_ROOT'];
$error  = false;

define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (!empty($_POST['bntsubmit']) && is_string($_POST['bntsubmit'])) {
    $bntsubmit = htmlspecialchars($_POST['bntsubmit'], ENT_QUOTES, 'UTF-8');
} else {
    $bntsubmit = null;
}
if ($bntsubmit != 'Update' && $bntsubmit != 'Continue') {
    die('Error');
}
$destination = 'temp.tar.gz';

$json   = file_get_contents('http://123solar.org/latest_version.php');
$data   = json_decode($json, true);
$lastv  = $data['LASTVERSION'];
$source = $data['LINK'];
$md5    = $data['md5'];

function progress()
{
    //echo '.';
    ob_flush();
    flush();
    //usleep(500); // some effects
}

function xcopy($source, $dest, $permissions)
{
    if (is_link($source)) { // Check for symlinks
        return symlink(readlink($source), $dest);
    }
    if (is_file($source)) { // Simple copy for a file
        return copy($source, $dest);
    }
    if (!is_dir($dest)) { // Make destination directory
        mkdir($dest, 0755);
    }
    $dir = dir($source); // Loop through the folder
    while (false !== $entry = $dir->read()) { // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }
        xcopy("$source/$entry", "$dest/$entry", $permissions); // Deep copy directories
    }
    $dir->close();
    return true;
}

if (!file_exists("$SRVDIR/_INSTALL/")) {
    if (!mkdir("$SRVDIR/_INSTALL/", 0777, true)) {
        $error = true;
        echo "<img src='../images/24/sign-error.png' width=24 height=24> Can't create $SRVDIR/_INSTALL. Make sure you didn't install 123solar on web server's root directory !<br>";
    }
    if (!is_writable("$SRVDIR/_INSTALL/")) {
        $error = true;
        echo "<img src='../images/24/sign-error.png' width=24 height=24> Can't write in $SRVDIR/_INSTALL/ <br>";
    }
}

if (file_exists("$SRVDIR/_INSTALL/123solar/scripts/version.php")) {
    include("$SRVDIR/_INSTALL/123solar/scripts/version.php");
    $stat = stat("$SRVDIR/_INSTALL/123solar/");
    $d    = date("d F Y H:i:s", $stat['ctime']);
    echo "<img src='../images/24/sign-error.png' width=24 height=24> An install directory already exist $SRVDIR/_INSTALL/ with $VERSION dated from $d.";
    if ($VERSION == $lastv) {
        $error = true;
        echo "<br>Please, finish that preinstallation.";
    } else {
        $error = true;
        echo "<br>Please, remove this directory to allow further updates.";
    }
}

if (!$error) {
    if (file_exists("$SRVDIR/_INSTALL/123solar/")) {
        rmdir("$SRVDIR/_INSTALL/123solar/");
    }
    // Check free space
    $bytes     = disk_free_space(".");
    $si_prefix = array(
        'B',
        'KB',
        'MB',
        'GB',
        'TB',
        'EB',
        'ZB',
        'YB'
    );
    $base      = 1024;
    $class     = min((int) log($bytes, $base), count($si_prefix) - 1);
    
    echo '<br>Checking free space ';
    echo sprintf('%1.2f', $bytes / pow($base, $class)) . ' ' . $si_prefix[$class];
    
    if ($bytes < 32000000) {
        $error = true;
        echo "<img src='../images/24/sign-error.png' width=24 height=24> You should have at least 32 MB left on your disk<br>";
    } else {
        echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
    }
    
    if (!$error) { // download
        ob_start();
        echo '<br>Downloading';
        ob_flush();
        flush();
        
        $fp = fopen("$destination", 'w+');
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "$source");
        //curl_setopt($ch, CURLOPT_BUFFERSIZE,128);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_PROGRESSFUNCTION, 'progress');
        curl_setopt($ch, CURLOPT_NOPROGRESS, false);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_FILE, $fp);
        curl_exec($ch);
        
        if (curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200) {
            $error = true;
            echo "<img src='../images/24/sign-error.png' width=24 height=24><br>";
        } else {
            echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
        }
        curl_close($ch);
        fclose($fp);
        ob_flush();
        flush();
    }
    
    if (!$error) {
        echo '<br>md5 check ';
        exec("md5sum $destination", $output);
        $pieces = explode(' ', $output[0]);
        if ($pieces[0] == $md5) {
            echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
        } else {
            $error = true;
            echo "<img src='../images/24/sign-error.png' width=24 height=24><br>";
            echo '<br>Cleaning : ';
            if (!unlink("$destination")) {
                echo "<img src='../images/24/sign-error.png' width=24 height=24> Can't remove $destination<br>";
            } else {
                echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
            }
        }
    }
    
    if (!$error) {
        echo '<br>Extract ';
        exec("tar -xzvf $destination -C $SRVDIR/_INSTALL/", $output, $return); // Return will return non-zero upon an error
        if (!$return) {
            echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
        } else {
            $error = true;
            echo "<img src='../images/24/sign-error.png' width=24 height=24> Error while extracting<br>";
        }
    }
    
    if (!$error) {
        echo '<br>Importing data ';
        if (!xcopy('../data/', "$SRVDIR/_INSTALL/123solar/data/", 0644)) {
            $error = true;
            echo "<img src='../images/24/sign-error.png' width=24 height=24> Failed to import data<br>";
        } else {
            echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
        }
        
        echo '<br>Importing config ';
        if (!xcopy('../config/', "$SRVDIR/_INSTALL/123solar/config/", 0644)) {
            $error = true;
            echo "<img src='../images/24/sign-error.png' width=24 height=24> Failed to import config<br>";
        } else {
            echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
        }
        if ($error) {
            $who = exec('whoami');
            echo "<textarea rows=3 cols=120 style='background-color:black;color: white;'>[root@plugpc ~]# chown $who:$who -R $CURDIR</textarea><br>";
        }
    }
    
    echo '<br>Cleaning ';
    if (!unlink("$destination")) {
        $error = true;
        echo "<img src='../images/24/sign-error.png' width=24 height=24> Can't remove $destination<br>";
    } else {
        echo "<img src='../images/24/sign-check.png' width=24 height=24><br>";
    }
    
    if (!$error) {
		echo '<br>Stopping 123solar ';
        exec('pkill -f 123solar.php', $output, $return);
        
        echo '<br><hr><br>';
        $d = date('Ymd');
        echo "<img src='../images/24/shield-ok.png' width=24 height=24> To complete the installation, you need to rename the old directory as a backup and move the newly created one.<br>
<br><img src='../images/24/sign-warning.png' width=24 height=24 border=0> Beware: Don't use a file manager only use those commands bellow in a terminal.<br>
<textarea rows=3 cols=120 style='background-color:black;color: white;'>
[root@logger ~]# sudo mv $CURDIR/ $CURDIR.$d/
[root@logger ~]# sudo mv $SRVDIR/_INSTALL/123solar/ $CURDIR/
[root@logger ~]# sync
</textarea>
	<br>
	<u>Side notes:</u> Previous personal modifications aren't imported (eg: styles/)
	<br>Please, also take this occasion to update your system.";
    } else {
        echo "<img src='../images/24/shield-error.png' width=24 height=24> The update didn't complete as expected !";
    }
}

echo "<br><br><INPUT TYPE='button' onClick=\"location.href='admin.php'\" value='Go back to admin'>";
?>
</td></tr>
</table>
</body>
</html>